include(CMakeParseArguments)

function(load_extern_cache)
    cmake_parse_arguments(EXT "" "CACHE_DIR" "VAR_LIST" ${ARGN})
    if(EXT_CACHE_DIR)
      load_cache(${EXT_CACHE_DIR} READ_WITH_PREFIX "EXT_" ${EXT_VAR_LIST})
      foreach(EXT_VAR ${EXT_VAR_LIST})
        if(EXT_${EXT_VAR})
            set(${EXT_VAR} ${EXT_${EXT_VAR}} CACHE STRING "" FORCE)
        endif()
      endforeach()
    endif (EXT_CACHE_DIR)
endfunction()

function(create_initial_cache cache_file)
    message(STATUS "Exporting cache: ${cache_file}")
    file(WRITE ${cache_file} "")
    get_cmake_property(CACHE_VARS CACHE_VARIABLES)
    foreach(cache_var ${CACHE_VARS})
        get_property(type CACHE ${cache_var} PROPERTY TYPE)
        get_property(advanced CACHE ${cache_var} PROPERTY ADVANCED)
        if(NOT type STREQUAL "INTERNAL")
            if(type STREQUAL "UNINITIALIZED")
                set(type "STRING")
            endif()
            file(APPEND ${cache_file} "set(${cache_var} \"${${cache_var}}\" CACHE ${type} \"Initial cache\")\n")
        endif()
    endforeach()
endfunction()

